import os
import inspect
from run import Module, CommandTask, FindVar, ValueVar, self
from .bootstrap import BootstrapModule
from .update import UpdateModule


class ProjectModule(Module):

    # Public

    def __init__(self):
        self._update_pythonpath()

    # Attributes

    author = '<author>'
    author_email = '<author_email>'
    caution = 'TO MAKE CHANGES USE "meta" DIRECTORY (see packgram docs).'
    classifiers = []
    copyright = '<copyright>'
    data_files = []
    description = '<description>'
    development_requires = []
    entry_points = {}
    install_requires = []
    interpreters = []
    license = '<license>'
    name = '<name>'
    platforms = []
    pypi_password_secure = '<pypi_password_secure>'
    tests_require = []
    test_suite = '<test_suite>'
    version = '<version>'

    # Modules

    bootstrap = BootstrapModule()
    update = UpdateModule()

    # Tasks

    # TODO: move to patterns?
    # TODO: docs_dir attr?
    document = CommandTask(
        'sphinx-build -b html -d docs/_build/doctrees docs docs/_build/html',
    )

    test = CommandTask(
        'nosetests tests',
    )

    # Vars

    long_description = FindVar(
        mode='strings',
        filepathes=['README.rst'],
        getfirst=True,
        fallback='',
    )

    github_user = ValueVar(
        value=self.author,
    )

    maintainer = ValueVar(
        value=self.author,
    )

    maintainer_email = ValueVar(
        value=self.author_email,
    )

    pypi_name = ValueVar(
        value=self.name,
    )

    pypi_user = ValueVar(
        value=self.author,
    )

    rtd_name = ValueVar(
        value=self.name,
    )

    # Protected

    def _update_pythonpath(self):
        os.environ['PYTHONPATH'] = ':'.join([
            os.environ.get('PYTHONPATH', ''),
            os.path.abspath(os.path.dirname(inspect.getfile(type(self))))])
