import os
import jinja2
from run import Module, RenderTask


# TODO: merge with ProjectModule?
# TODO: rebase on RenderTask with mode='dir'
class UpdateModule(Module):

    # Meta

    meta_default_task = 'update'
    meta_inherit = True

    # Tasks

    # TODO: ignore files like __pycache__/*?
    def update(self):
        root = 'meta'
        if os.path.isdir(root):
            for dirpath, _, filenames in os.walk(root):
                for filename in sorted(filenames):
                    source = os.path.join(dirpath, filename)
                    target = os.path.relpath(source, start=root)
                    self.render_file(filepath=source, target=target)

    render_file = RenderTask(
        mode='file',
        trim_blocks=True,
        lstrip_blocks=True,
        loader=jinja2.ChoiceLoader([
            jinja2.FileSystemLoader('.'),
            jinja2.PrefixLoader({
                'packgram': jinja2.PackageLoader('packgram', 'templates')
            })
        ])
    )
